Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Interface Multimap<K,V>

Type Parameters:
  `K` - the type of keys maintained by this multimap
  `V` - the type of mapped values

All Known Subinterfaces:
  ListMultimap<K,V>, SetMultimap<K,V>, SortedSetMultimap<K,V>

All Known Implementing Classes:
  ArrayListMultimap, ForwardingListMultimap, ForwardingMultimap, ForwardingSetMultimap, ForwardingSortedSetMultimap, HashMultimap, ImmutableListMultimap, ImmutableMultimap, ImmutableSetMultimap, LinkedHashMultimap, LinkedListMultimap, TreeMultimap

    @GwtCompatible
    public interface Multimap<K,V>

A collection similar to a `Map`, but which may associate multiple values with a single key. If you call `put(K, V)` twice, with the same key but different values, the multimap contains mappings from the key to both values.

The methods `get(K)`, `keySet()`, `keys()`, `values()`, `entries()`, and `asMap()` return collections that are views of the multimap. If the multimap is modifiable, updating it can change the contents of those collections, and updating the collections will change the multimap. In contrast, `replaceValues(K, java.lang.Iterable)` and `removeAll(java.lang.Object)` return collections that are independent of subsequent multimap changes.

Depending on the implementation, a multimap may or may not allow duplicate key-value pairs. In other words, the multimap contents after adding the same key and value twice varies between implementations. In multimaps allowing duplicates, the multimap will contain two mappings, and `get` will return a collection that includes the value twice. In multimaps not supporting duplicates, the multimap will contain a single mapping from the key to the value, and `get` will return a collection that includes the value once.

All methods that alter the multimap are optional, and the views returned by the multimap may or may not be modifiable. When modification isn't supported, those methods will throw an `UnsupportedOperationException`.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy

Method Summary
`Map<K,Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
`void` | `clear()` Removes all key-value pairs from the multimap.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`Collection<Map.Entry<K,V>>` | `entries()` Returns a collection of all key-value pairs.
`boolean` | `equals(Object obj)` Compares the specified object with this multimap for equality.
`Collection<V>` | `get(K key)` Returns a collection view of all values associated with a key.
`int` | `hashCode()` Returns the hash code for this multimap.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`Multiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`Set<K>` | `keySet()` Returns the set of all keys, each appearing once in the returned set.
`boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Stores a collection of values with the same key.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Copies all of another multimap's key-value pairs into this multimap.
`boolean` | `remove(Object key, Object value)` Removes a key-value pair from the multimap.
`Collection<V>` | `removeAll(Object key)` Removes all values associated with a given key.
`Collection<V>` | `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`Collection<V>` | `values()` Returns a collection of all values in the multimap.

Method Detail

### size

    int size()

  Returns the number of key-value pairs in the multimap.

### isEmpty

    boolean isEmpty()

  Returns `true` if the multimap contains no key-value pairs.

### containsKey

    boolean containsKey(@Nullable
                        Object key)

  Returns `true` if the multimap contains any values for the specified key.

  Parameters:
    `key` - key to search for in multimap

### containsValue

    boolean containsValue(@Nullable
                          Object value)

  Returns `true` if the multimap contains the specified value for any key.

  Parameters:
    `value` - value to search for in multimap

### containsEntry

    boolean containsEntry(@Nullable
                          Object key,
                          @Nullable
                          Object value)

  Returns `true` if the multimap contains the specified key-value pair.

  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### put

    boolean put(@Nullable
                K key,
                @Nullable
                V value)

  Stores a key-value pair in the multimap.

  Some multimap implementations allow duplicate key-value pairs, in which case `put` always adds a new key-value pair and increases the multimap size by 1. Other implementations prohibit duplicates, and storing a key-value pair that's already in the multimap has no effect.

  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates

### remove

    boolean remove(@Nullable
                   Object key,
                   @Nullable
                   Object value)

  Removes a key-value pair from the multimap.

  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed

### putAll

    boolean putAll(@Nullable
                   K key,
                   Iterable<? extends V> values)

  Stores a collection of values with the same key.

  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed

### putAll

    boolean putAll(Multimap<? extends K,? extends V> multimap)

  Copies all of another multimap's key-value pairs into this multimap. The order in which the mappings are added is determined by `multimap.entries()`.

  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed

### replaceValues

    Collection<V> replaceValues(@Nullable
                                K key,
                                Iterable<? extends V> values)

  Stores a collection of values with the same key, replacing any existing values for that key.

  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

### removeAll

    Collection<V> removeAll(@Nullable
                            Object key)

  Removes all values associated with a given key.

  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### clear

    void clear()

  Removes all key-value pairs from the multimap.

### get

    Collection<V> get(@Nullable
                      K key)

  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### keySet

    Set<K> keySet()

  Returns the set of all keys, each appearing once in the returned set. Changes to the returned set will update the underlying multimap, and vice versa.

  Returns:
    the collection of distinct keys

### keys

    Multiset<K> keys()

  Returns a collection, which may contain duplicates, of all keys. The number of times of key appears in the returned multiset equals the number of mappings the key has in the multimap. Changes to the returned multiset will update the underlying multimap, and vice versa.

  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### values

    Collection<V> values()

  Returns a collection of all values in the multimap. Changes to the returned collection will update the underlying multimap, and vice versa.

  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

### entries

    Collection<Map.Entry<K,V>> entries()

  Returns a collection of all key-value pairs. Changes to the returned collection will update the underlying multimap, and vice versa. The entries collection does not support the `add` or `addAll` operations.

  Returns:
    collection of map entries consisting of key-value pairs

### asMap

    Map<K,Collection<V>> asMap()

  Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue()` on its entries, `put`, or `putAll`.

  When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

  Returns:
    a map view from a key to its collection of values

### equals

    boolean equals(@Nullable
                   Object obj)

  Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `asMap()`, are also equal.

  In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

  A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `asMap()` views.

  Overrides:
    `equals` in class `Object`

### hashCode

    int hashCode()

  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `asMap()`.

  Overrides:
    `hashCode` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.